
_Interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;forum.c,31 :: 		void Interrupt(){
;forum.c,34 :: 		if (TMR0IF_bit){                                                            // handle timer 0 interrupt
	BTFSS      TMR0IF_bit+0, BitPos(TMR0IF_bit+0)
	GOTO       L_Interrupt0
;forum.c,35 :: 		TMR0IF_bit = 0;
	BCF        TMR0IF_bit+0, BitPos(TMR0IF_bit+0)
;forum.c,36 :: 		if(PWM1_level_next){                                                    // was high - now needs to go low
	MOVF       _PWM1_level_next+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_Interrupt1
;forum.c,37 :: 		PORTD.B0 = 1;                                                       // PWM1 on RB0 high 0.5 to 2.5 ms
	BSF        PORTD+0, 0
;forum.c,38 :: 		PWM1_low_count = 0;
	CLRF       _PWM1_low_count+0
;forum.c,39 :: 		PWM1_level_next = 0;                                                // set next flag low
	CLRF       _PWM1_level_next+0
;forum.c,40 :: 		TMR0 = 226 - (PWM1_high_time >> 1);                                 // set new high time. 0.5mS minimum, 2.5ms max
	MOVF       _PWM1_high_time+0, 0
	MOVWF      R0+0
	MOVF       _PWM1_high_time+1, 0
	MOVWF      R0+1
	RRF        R0+1, 1
	RRF        R0+0, 1
	BCF        R0+1, 7
	MOVF       R0+0, 0
	SUBLW      226
	MOVWF      TMR0+0
;forum.c,41 :: 		}
	GOTO       L_Interrupt2
L_Interrupt1:
;forum.c,43 :: 		PORTD.B0 = 0;                                                       // PWM1 on RB0 low
	BCF        PORTD+0, 0
;forum.c,44 :: 		PWM1_low_count++;                                                   // T0 times out 5 times to extend low time  5 x 3.25 = 16.25 ms
	INCF       _PWM1_low_count+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _PWM1_low_count+0
;forum.c,45 :: 		if(PWM1_low_count < 6){                                             // count longish time x 6 to get over limited T0 timing capability
	MOVLW      6
	SUBWF      _PWM1_low_count+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_Interrupt3
;forum.c,46 :: 		TMR0 = 43;                                                      // set new 1 sixth of low time - 3.25 ms
	MOVLW      43
	MOVWF      TMR0+0
;forum.c,47 :: 		}
	GOTO       L_Interrupt4
L_Interrupt3:
;forum.c,49 :: 		TMR0 = 114 + (PWM1_high_time >> 1);                             // set final adjusted low time 256-114 to 256-114+(252/2) - leaves 142 to 16
	MOVF       _PWM1_high_time+0, 0
	MOVWF      R0+0
	MOVF       _PWM1_high_time+1, 0
	MOVWF      R0+1
	RRF        R0+1, 1
	RRF        R0+0, 1
	BCF        R0+1, 7
	MOVF       R0+0, 0
	ADDLW      114
	MOVWF      TMR0+0
;forum.c,50 :: 		PWM1_level_next = 1;                                            // set next flag high
	MOVLW      1
	MOVWF      _PWM1_level_next+0
;forum.c,51 :: 		PWM1_low_count = 0;                                             // reset 5-count ready for next time
	CLRF       _PWM1_low_count+0
;forum.c,52 :: 		}
L_Interrupt4:
;forum.c,53 :: 		}
L_Interrupt2:
;forum.c,54 :: 		}
L_Interrupt0:
;forum.c,56 :: 		if (TMR1IF_bit){                                                            // handle timer 1 interrupt
	BTFSS      TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
	GOTO       L_Interrupt5
;forum.c,57 :: 		TMR1IF_bit = 0;
	BCF        TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
;forum.c,58 :: 		if(PWM2_level_next){                                                    // was high - next time needs to go low
	MOVF       _PWM2_level_next+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_Interrupt6
;forum.c,59 :: 		PORTD.B1 = 1;                                                       // PWM on RB1 high
	BSF        PORTD+0, 1
;forum.c,60 :: 		PWM2_level_next = 0;                                                // set next flag low
	CLRF       _PWM2_level_next+0
;forum.c,61 :: 		TMR1_value = 65479 - (PWM2_high_time);                              // calculate 16 bit timer 1 value adjusted for high time
	MOVF       _PWM2_high_time+0, 0
	SUBLW      199
	MOVWF      R3+0
	MOVF       _PWM2_high_time+1, 0
	BTFSS      STATUS+0, 0
	ADDLW      1
	SUBLW      255
	MOVWF      R3+1
;forum.c,62 :: 		TMR1H = TMR1_value >> 8;                                            // high byte
	MOVF       R3+1, 0
	MOVWF      R0+0
	CLRF       R0+1
	MOVF       R0+0, 0
	MOVWF      TMR1H+0
;forum.c,63 :: 		TMR1L = TMR1_value & 0xff;                                          // set new high time.
	MOVLW      255
	ANDWF      R3+0, 0
	MOVWF      TMR1L+0
;forum.c,64 :: 		}
	GOTO       L_Interrupt7
L_Interrupt6:
;forum.c,66 :: 		PORTD.B1 = 0;                                                       // PWM2 on RB1 low
	BCF        PORTD+0, 1
;forum.c,67 :: 		TMR1_value = 63100 + (PWM2_high_time);                              // 16 bit timer 1 value adjusted for low time
	MOVF       _PWM2_high_time+0, 0
	ADDLW      124
	MOVWF      R3+0
	MOVLW      246
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      _PWM2_high_time+1, 0
	MOVWF      R3+1
;forum.c,68 :: 		TMR1H = TMR1_value >> 8;                                            // high byte
	MOVF       R3+1, 0
	MOVWF      R0+0
	CLRF       R0+1
	MOVF       R0+0, 0
	MOVWF      TMR1H+0
;forum.c,69 :: 		TMR1L = TMR1_value & 0xff;                                          // set new low time
	MOVLW      255
	ANDWF      R3+0, 0
	MOVWF      TMR1L+0
;forum.c,70 :: 		PWM2_level_next = 1;                                                // set flag for next time needs to go high
	MOVLW      1
	MOVWF      _PWM2_level_next+0
;forum.c,71 :: 		}
L_Interrupt7:
;forum.c,72 :: 		}
L_Interrupt5:
;forum.c,73 :: 		}
L_end_Interrupt:
L__Interrupt11:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _Interrupt

_main:

;forum.c,75 :: 		void main(){
;forum.c,77 :: 		TRISC = 0;                                                                  // all output
	CLRF       TRISC+0
;forum.c,78 :: 		TRISD = 0;                                                                  // all output
	CLRF       TRISD+0
;forum.c,79 :: 		PORTC = 0;                                                                  // all outputs low
	CLRF       PORTC+0
;forum.c,80 :: 		PORTD = 0;                                                                  // all outputs low
	CLRF       PORTD+0
;forum.c,82 :: 		OPTION_REG = 0x83;                                                          // Timer0 Prescaler 1:4, FOSC/4, On
	MOVLW      131
	MOVWF      OPTION_REG+0
;forum.c,84 :: 		T1CON = 0x31;                                                               // 1:8 prescale, FOSC/4, On
	MOVLW      49
	MOVWF      T1CON+0
;forum.c,85 :: 		TMR1IF_bit = 0;                                                             // disable T1 Interrupt while adjusting
	BCF        TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
;forum.c,86 :: 		TMR1H = 0xff;                                                               // don't care - will be adjusted later
	MOVLW      255
	MOVWF      TMR1H+0
;forum.c,87 :: 		TMR1L = 0xE0;                                                               // don't care - will be adjusted later
	MOVLW      224
	MOVWF      TMR1L+0
;forum.c,88 :: 		TMR1IE_bit = 1;                                                             // now ready for interrupt
	BSF        TMR1IE_bit+0, BitPos(TMR1IE_bit+0)
;forum.c,89 :: 		INTCON = 0xE0;                                                              // enable T0 int, peripheral int, global int
	MOVLW      224
	MOVWF      INTCON+0
;forum.c,91 :: 		while(1){                                                                   // main loop
L_main8:
;forum.c,92 :: 		PWM1_high_time = ADC_Read(0)/4;                                         // 0 = 0.5mS, 252 = 2.5mS
	CLRF       FARG_ADC_Read_channel+0
	CALL       _ADC_Read+0
	MOVF       R0+0, 0
	MOVWF      R2+0
	MOVF       R0+1, 0
	MOVWF      R2+1
	RRF        R2+1, 1
	RRF        R2+0, 1
	BCF        R2+1, 7
	RRF        R2+1, 1
	RRF        R2+0, 1
	BCF        R2+1, 7
	MOVF       R2+0, 0
	MOVWF      _PWM1_high_time+0
	MOVF       R2+1, 0
	MOVWF      _PWM1_high_time+1
;forum.c,93 :: 		PWM2_high_time = ADC_Read(1)/4;                                         // 0 = 0.5mS, 252 = 2.5mS
	MOVLW      1
	MOVWF      FARG_ADC_Read_channel+0
	CALL       _ADC_Read+0
	MOVF       R0+0, 0
	MOVWF      R2+0
	MOVF       R0+1, 0
	MOVWF      R2+1
	RRF        R2+1, 1
	RRF        R2+0, 1
	BCF        R2+1, 7
	RRF        R2+1, 1
	RRF        R2+0, 1
	BCF        R2+1, 7
	MOVF       R2+0, 0
	MOVWF      _PWM2_high_time+0
	MOVF       R2+1, 0
	MOVWF      _PWM2_high_time+1
;forum.c,94 :: 		}
	GOTO       L_main8
;forum.c,95 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
